<?php if (!defined('BASEPATH')) exit('No direct script access allowed'); 

/**
 * comuser_uploader - плагин для MaxSite CMS 
 * загрузка файлов комюзерами и вставка в комментарий
**/


# функция автоподключения плагина
function comuser_uploader_autoload($args = array())
{	
	mso_create_allow('comuser_uploader',  t('Админ-доступ к настройкам', 'admin'));
	mso_hook_add( 'admin_init', 'comuser_uploader_admin_init');
	mso_hook_add( 'head', 'comuser_uploader_head');
	
	// mso_hook_add( 'forum_comments_content_end', 'comuser_uploader_comments'); // для вставки формы загрузки по хуку редактора форума 
	
	mso_hook_add( 'comments_content_end', 'comuser_uploader_comments'); // для формы загрузки изображений в комментарий
	mso_hook_add( 'comments_content', 'comuser_uploader_content'); // хук на вывод контента после обработки всех тэгов
	mso_hook_add( 'comment_button_more', 'comuser_uploader_button'); // хук на вывод кнопки в bb-коды
}


function comuser_uploader_comments($args = array()) 
{
  // вывод формы загрузки изображений пользователями после комментария
  if ($comuser = is_login_comuser())
  {
	$type = false; // вызов из комментирования
	require(getinfo('plugins_dir') . 'comuser_uploader/manager-comuser.php');
  }	  
  return $args;
}

function comuser_uploader_head($args = array()) 
{
  if ($comuser = is_login_comuser())
  {	
    echo '<link rel="stylesheet" href="' . getinfo('plugins_url') . 'comuser_uploader/style_comments.css">';  	
    echo '<script src="'. getinfo('plugins_url') . 'comment_smiles/comment_smiles.js"></script>';	
	echo '<script src="' . getinfo('plugins_url') . 'comuser_uploader/filedrag.js' . '"></script>';
  }	
  return $args;
}

function comuser_uploader_content($text = '') 
{
	$options = mso_get_option('comuser_uploader', 'plugins', array() );	
    $subdir = (isset($options['user_subdir'])) ? $options['user_subdir'] : 'userfile';
    $style  = (isset($options['google_pdf_style'])) ? $options['google_pdf_style'] : 'width: 600px; height: 200px;';	
    $frame  = (isset($options['frame'])) ? $options['frame'] : 1;	
	
	$url = getinfo('uploads_url') . $subdir . '/';
	$doc_url = getinfo('admin_url') . 'plugins/admin_files/document_plain.png';

		
	$preg = array(
		'~\[myimg=(.[^ ]*?)\](.*?)\[\/myimg\]~si' => '<a href="' . $url . '$1/$2" class="lightbox"><img title="$2" src="' . $url . '$1/mini/$2" alt="$2"></a>',
		'~\[myfile=(.[^ ]*?)\](.*?)\[\/myfile\]~si' => '<a target="_blank" href="' . $url . '$1/$2"><img title="$2" src="' . $doc_url . '" alt="$2"></a>',
	);

	if ($frame) $preg['~\[mydoc=(.[^ ]*?)\](.*?)\[\/mydoc\]~si'] = '<iframe src="https://docs.google.com/viewer?url=' . $url . '$1/$2&embedded=true" style="' . $options['google_pdf_style'] . '" frameborder="0">Ваш браузер не поддерживает фреймы</iframe>';
    else $preg['~\[mydoc=(.[^ ]*?)\](.*?)\[\/mydoc\]~si'] = '<a target="_blank" href="' . $url . '$1/$2"><img title="$2" src="' . $doc_url . '" alt="$2"></a>';

   return preg_replace(array_keys($preg), array_values($preg), $text);
}

function comuser_uploader_admin_init($args = array()) 
{	
	if ( !mso_check_allow('comuser_uploader') ) 
	{
		return $args;
	}

	$this_plugin_url = 'comuser_uploader'; // url и hook
	mso_admin_menu_add('plugins', $this_plugin_url, '' . t('Загрузки комюзеров', 'admin') . '');
	mso_admin_url_hook ($this_plugin_url, 'comuser_uploader_admin');
	
	return $args;
}

// добавляем кнопку в bb-коды
function comuser_uploader_button() 
{	
	  if ($comuser = is_login_comuser()) return '<button type="text" id="all-files-upload" class="comment_button_i all-files-upload button i-upload" title="' . t('Файл') . '">' . t('Файлы') . '</button>';
}

// администрирование загрузок комюзерами
function comuser_uploader_admin($args = array()) 
{
	if ( !mso_check_allow('comuser_uploader') ) 
	{
		echo 'Доступ запрещен';
		return $args;
	}
	mso_hook_add_dinamic( 'mso_admin_header', ' return $args . "' . t('Загрузки комюзеров - управление', 'admin') . '"; ' );
	mso_hook_add_dinamic( 'admin_title', ' return "' . t('Загрузки комюзеров', 'admin') . ' - " . $args; ' );
	require(getinfo('plugins_dir') . 'comuser_uploader/admin/index.php');
}

// настройки загрузок комьзерами
function comuser_uploader_mso_options() 
{
	mso_admin_plugin_options('comuser_uploader', 'plugins', 
		array(
			'allowed_types_comuser' => array(
						'type' => 'text', 
						'name' => t('Разрешенные типы файлов', 'plugins'), 
						'description' => t('Список типов файлов, которые может загружать комюзер (типы указывать через |)', 'plugins'),
						'default' => 'gif|jpg|jpeg|png|pdf'
			),

			'frame_types_comuser' => array(
						'type' => 'text', 
						'name' => t('Типы файлов - документов, для которых будет создаваться bb-код [mydoc]', 'plugins'), 
						'description' => t('Для остальных будет создаваться bb-код [myfile]', 'plugins'),
						'default' => '|pdf'
			),
			
			'user_subdir' => array(
						'type' => 'text', 
						'name' => t('Subdir', 'plugins'), 
						'description' => t('Подкаталог в каталоге uploads для загрузки комюзерами.', 'plugins'),
						'default' => 'userfile'
			),	

			'frame' => array(
						'type' => 'select',
						'name' => t('Создавать фрейм?', 'plugins'),
						'description' => t('Для bb-кода [mydoc] будет создаваться фрейм', 'plugins'),
						'values' => t('1||Да #0||Нет', 'plugins'),
						'default' => '1'
			),
			
			'no_public_uploads' => array(
						'type' => 'select',
						'name' => t('Запретить доступ к загрузкам комьюзера чужим комюзерам', 'plugins'),
						'description' => t('Невозможно будет получить аякс-запросом картинки пользователя другому пользовтелю', 'plugins'),
						'values' => t('1||Да #0||Нет', 'plugins'),
						'default' => '0'
			),
/* 
			'add_cod_img' => array( // может пригодится
						'type' => 'select',
						'name' => t('Вставлять изображение', 'plugins'),
						'description' => t('Будет вставлятся полное изображение, миниатюра или bb-код', 'plugins'),
						'values' => t('0||bb-код 1||Миниатюра #2||Полное', 'plugins'),
						'default' => '0'
			),
			
			'add_cod_file' => array( // может пригодится
						'type' => 'select',
						'name' => t('Вставлять файл', 'plugins'),
						'description' => t('Будет ссылка или bb-код', 'plugins'),
						'values' => t('0||bb-код #1||Ссылка', 'plugins'),
						'default' => '0'
			),
*/			
			'show_size' => array(
						'type' => 'select',
						'name' => t('Показывать размер', 'plugins'),
						'description' => t('Показывать размер файлов возле имени?', 'plugins'),
						'values' => t('1||Да #2||Нет', 'plugins'),
						'default' => '1'					
			),
			
			'resize_images' => array(
						'type' => 'text', 
						'name' => t('Ресайз для комюзеров', 'plugins'),
						'description' => t('Укажите размер изображения до которого будет ограничиваться при загрузке комюзером.', 'plugins'),
						'default' => '600'				
			),	

			'resize_images_type' => array(
						'type' => 'select', 
						'name' => t('Ресайз для комюзеров - тип', 'plugins'),
						'description' => t('resize_images_type', 'plugins'),
						'values' => t('width||width #height||height #max||max #crop_center_ratio_auto||crop_center_ratio_auto #crop_center_ratio_4_3||crop_center_ratio_4_3 #crop_center_ratio_3_2||crop_center_ratio_3_2 #crop_center_ratio_16_9||crop_center_ratio_16_9', 'plugins'),
						'default' => 'width'				
			),

			'size_image_mini_w' => array(
						'type' => 'text', 
						'name' => t('Ресайз для комюзеров', 'plugins'),
						'description' => t('size_image_mini_w', 'plugins'),
						'default' => '200'				
			),
			
			'size_image_mini_h' => array(
						'type' => 'text', 
						'name' => t('Ресайз для комюзеров', 'plugins'),
						'description' => t('size_image_mini_h', 'plugins'),
						'default' => '150'				
			),			

			'resize_mini_type' => array(
						'type' => 'select', 
						'name' => t('Ресайз mini для комюзеров', 'plugins'),
						'description' => t('resize_mini_type', 'plugins'),
						'values' => t('none||none #width||width #height||height #max||max #crop_center_ratio_auto||crop_center_ratio_auto #crop_center_ratio_4_3||crop_center_ratio_4_3 #crop_center_ratio_3_2||crop_center_ratio_3_2 #crop_center_ratio_16_9||crop_center_ratio_16_9', 'plugins'),
						'default' => 'width'				
			),
			
			'use_watermark' => array(
						'type' => 'select',
						'name' => t('Watermark', 'plugins'),
						'description' => t('Ставить watermark?', 'plugins'),
						'values' => t('1||Да #0||Нет', 'plugins'),
						'default' => '0'					
			),	
			
			'use_watermark_mini' => array(
						'type' => 'select',
						'name' => t('Watermark mini', 'plugins'),
						'description' => t('Ставить watermark у миниатюры?', 'plugins'),
						'values' => t('1||Да #0||Нет', 'plugins'),
						'default' => '0'					
			),	
			
			'upload_max_file_size' => array(
						'type' => 'text',
						'name' => t('Максимальный размер файла', 'plugins'),
						'description' => t('upload_max_file_size', 'plugins'),
						'default' => '20000000'					
			),	

			'google_pdf_style' => array(
						'type' => 'text',
						'name' => t('Дополнительные стили фрейма', 'plugins'),
						'description' => t('width: 600px; height: 600px;', 'plugins'),
						'default' => 'width: 600px; height: 200px;'					
			),			
		),
		t('Загрузки комюзеров - настройки', 'plugins'), // титул
		t('Укажите необходимые опции.', 'plugins')   // инфо
	);
}


?>